/**
 * All the scripts needed the events custom post type
 */

class SGC_Event {

    constructor( ) {
        SGC_Event.event_id = $('#post_ID').val();
        SGC_Event.team_id = null;
        SGC_Event.players = [];
        SGC_Event.checkedin = [];
        SGC_Event.groupcount = 0;

        SGC_Event.groups = [];

        //populate the checkedin players list
        $.getJSON(SGC.siteurl + '/wp-json/simplegolfclub/v1/event/checkin/' + SGC_Event.event_id, function (result) {
            // Build the checkedin array
            SGC_Event.checkedin = JSON.parse( result );
        }).done(function () {
            SGC_Event.get_player_list();
            SGC_Event.get_groups();
        });
    }

    /**
     * 
     */
    update_player_list() {
        SGC_Event.get_player_list();
    }

    /**
     * 
     */
    add_group() {
        SGC_Event.groupcount++;
        
        // Add a blank group to the array
        SGC_Event.groups.push({
            'gid': SGC_Event.groupcount,
            'name': '',
            'order': SGC_Event.groupcount,
            'players': []
        });

        SGC_Event.display_groups();
        return false;
    }

    /**
     * 
     */
    save_groups() {
        // Save the array to the form element
        if (SGC_Event.groups.length > 0) {
            $('#sgc_eventgroups').val(JSON.stringify(SGC_Event.groups).replace(/[\\"]/g, "'"));
        } else {
            $('#sgc_eventgroups').val('');
        }
        // close the thickbox
        tb_remove();

        return false;
    }

    /**
     * 
     */
    static add_player() {
        var gid = $(this).attr('group');

        // loop through the list of groups and find the matching ID

        for (var i = 0; i < SGC_Event.groups.length; i++) {
            if (SGC_Event.groups[i].gid == gid) {
                var pid = $('#sgc_eventgroup_' + i + '_players').find('option:selected').val();
                var name = $('#sgc_eventgroup_' + i + '_players').find('option:selected').attr('name');

                if (pid > 0) {
                    SGC_Event.groups[i].players.push({'pid': pid, 'name': name});

                    SGC_Event.display_groups();
                }
            }
        }
        return false;
    }

    static del_player() {
        var gid = $(this).attr('group');
        var pid = $(this).attr('player');

        if (gid > 0 && pid > 0) {
            for (var i = 0; i < SGC_Event.groups.length; i++) {
                if (SGC_Event.groups[i].gid == gid) {
                    for (var j = 0; j < SGC_Event.groups[i].players.length; j++) {
                        if (SGC_Event.groups[i].players[j].pid == pid) {
                            SGC_Event.groups[i].players.splice(j, 1);

                            SGC_Event.display_groups();
                        }
                    }
                }
            }
        }
        return false;
    }

    /**
     * 
     */
    static update_groupname() {
        var gid = $(this).attr('group');
        var name = $(this).val();

        if (gid > 0) {
            for (var i = 0; i < SGC_Event.groups.length; i++) {
                if (SGC_Event.groups[i].gid == gid) {
                    SGC_Event.groups[i].name = name;
                }
            }
        }
    }
    /**
     * 
     */
    static del_group( ) {
        var gid = $(this).attr('group');
        
        // loop through the list of groups and remove the matching ID
        for (var i = 0; i < SGC_Event.groups.length; i++) {
            if (SGC_Event.groups[i].gid == gid) {
                SGC_Event.groups.splice(i, 1);
                SGC_Event.display_groups();
            }
        }
        return false;
    }

    /**
     * 
     */
    static get_player_list() {
        // Get the Team ID
        SGC_Event.team_id = $('#sgc_eventteam').find('option:selected').val();

        // Call rest API for list of players by team ID
        if (SGC_Event.team_id > 0) {
            // Clear the player list
            SGC_Event.players = [];
            
            // Fetch all players list
            $.getJSON(SGC.siteurl + '/wp-json/simplegolfclub/v1/team/players/' + SGC_Event.team_id, function (result) {
                
                console.log(SGC_Event.checkedin);
                // Build the players array
                for (var i = 0; i < result.length; i++) {
                    // is player checkedin?
                    var iPCi = false;
                    for (var j = 0; j < SGC_Event.checkedin.length; j++) {
                        if ( SGC_Event.checkedin[j] == result[i].ID ) { iPCi = true; }
                    }
                    
                    //Add the player to the array
                    SGC_Event.players.push({'ID': result[i].ID, 'Name': result[i].post_title, 'CheckedIn': iPCi});
                }
            }).done(function () {
                console.log( SGC_Event.players);
                // Refresh the group list
                SGC_Event.display_groups();
            });
        }
    }

    /**
     * 
     */
    static get_groups() {
        // fetch group JSON array from post
        try {
            SGC_Event.groups = JSON.parse($('#sgc_eventgroups').val().replace(/[']/g, '\"'));
            SGC_Event.groupcount = SGC_Event.groups.length + 1;
        } catch (e) {
            console.log('not a valid json string');
        }
    }

    /**
     * 
     */
    static display_groups( ) {
        // Clear the grouplist
        $('#sgc_event_grouplist').html('');

        // Loop through the group array and build the group dialogs
        for (var i = 0; i < SGC_Event.groups.length; i++) {
            // Create the group container
            $('#sgc_event_grouplist')
                    .append('<div class="sgc_eventgroup" id="sgc_eventgroup_' + i + '" '
                            + '" style="display: inline-block"></div>');

            // Add the group Heading
            $('#sgc_eventgroup_' + i)
                    .append('<div>'
                            + '<input type="text" id="sgc_eventgroup_' + i + '_name" placeholder="Group Name..." group="' + SGC_Event.groups[i].gid + '" value="' + SGC_Event.groups[i].name + '"/>'
                            + '<a href="" id="sgc_eventgroup_' + i + '_delete" group="' + SGC_Event.groups[i].gid + '">Delete</a>'
                            + '</div>');
            // bind events
            $('#sgc_eventgroup_' + i + '_name').change(SGC_Event.update_groupname);
            $('#sgc_eventgroup_' + i + '_delete').click(SGC_Event.del_group);

            // Add the player selection list
            $('#sgc_eventgroup_' + i)
                    .append('<div>'
                            + '<select id="sgc_eventgroup_' + i + '_players">'
                            + '<option value="-1">Select a Player...</option>'
                            + '</select>'
                            + '<a href="" id="sgc_eventgroup_' + i + '_playeradd" group="' + SGC_Event.groups[i].gid + '">Add</a>'
                            + '</div>');

            // Populate the player selection list
            for (var j = 0; j < SGC_Event.players.length; j++) {
                console.log(SGC_Event.players[j]);
                if ( SGC_Event.players[j].CheckedIn ) {
                    $('#sgc_eventgroup_' + i + '_players')
                            .append('<option value="' + SGC_Event.players[j].ID + '" name="' + SGC_Event.players[j].Name + '">&#10003' + SGC_Event.players[j].Name + '</option>');
                } else {
                    $('#sgc_eventgroup_' + i + '_players')
                            .append('<option value="' + SGC_Event.players[j].ID + '" name="' + SGC_Event.players[j].Name + '">&nbsp;&nbsp;&nbsp;' + SGC_Event.players[j].Name + '</option>');
                }
            }
            $('#sgc_eventgroup_' + i + '_playeradd').click(SGC_Event.add_player);

            // Add the group body
            $('#sgc_eventgroup_' + i)
                    .append('<div class="sgc_eventgroup_players" id="sgc_eventgroup_' + i + '_players">'
                            + '<ul id="sgc_eventgroup_' + i + '_players"></ul>'
                            + '</div>');

            // Populate the group body
            if (SGC_Event.groups[i].players.length > 0) {
                for (var j = 0; j < SGC_Event.groups[i].players.length; j++) {
                    $('ul[id=sgc_eventgroup_' + i + '_players]')
                            .append('<li class="sgc_eventgroup_players">' + SGC_Event.groups[i].players[j].name
                                    + ' <a href="" id="sgc_eventgroup_' + i + '_player_' + SGC_Event.groups[i].players[j].pid + '_del' + '" '
                                    + 'group="' + SGC_Event.groups[i].gid + '" player="' + SGC_Event.groups[i].players[j].pid + '">delete</a></li>');
                    // bind events
                    $('#sgc_eventgroup_' + i + '_player_' + SGC_Event.groups[i].players[j].pid + '_del').click(SGC_Event.del_player);
                }
            }
        }
    }
}
