<?php

/**
 * Provide ui for entering in date/time
 *
 * This file is used to markup the admin-facing aspects of the plugin.
 *
 * @link       https://bitbucket.org/matthewlinton/
 * @since      1.0.0
 *
 * @package    Simplegolfclub
 * @subpackage Simplegolfclub/admin/partials
 */
?>
<!-- This file should primarily consist of HTML with a little bit of PHP. -->

<div class="container">
<input type="hidden" id="sgc_javascript" value="sgc_event">
<table class="formtable">
<tbody>
	<tr>
		<th><label for="sgc_eventdate">Date</label></th>
		<td><input type="text" name="sgc_eventdate" id="sgc_eventdate" placeholder="Date..." value="<?php if($event_date) { echo $event_date; } ?>" />
			<script type="text/javascript">$("#sgc_eventdate").pickadate()</script></td>
	</tr>
	<tr>
		<th><label for="sgc_eventtime">Time</label></th>
		<td><input type="text" name="sgc_eventtime" id="sgc_eventtime" placeholder="Time..." value="<?php if($event_time) { echo $event_time; } ?>" />
			<script type="text/javascript">$("#sgc_eventtime").pickatime({ min: [9,0], max: [20,0] })</script></td>
	</tr>
	<tr>
		<th><label for="sgc_eventteam">Team</label></th>
		<td> <select name="sgc_eventteam" id="sgc_eventteam">
            <option value="-1">Select Team...</option>
            <?php foreach ( $teams as $post ) : setup_postdata( $post ); ?>
            <option value="<?= the_ID() ?>" <?php selected($post->ID, $event_team); ?>><?= the_title() ?></option>
            <?php endforeach; ?>
        </select></td>
	</tr>
	<tr>
		<th><label for="sgc_eventlocation">Location</label></th>
		<td><select name="sgc_eventlocation" id="sgc_eventlocation">
            <option value="-1">Select Location...</option>
            <?php foreach ( $locations as $post ) : setup_postdata( $post );  ?>
            <option value="<?= the_ID() ?>" <?php selected($post->ID, $event_location); ?>><?= the_title() ?></option>
            <?php endforeach; ?>
        </select></td>
	</tr>
	<tr>
    	<th>&nbsp;</th>
    	<td>
            <input type="hidden" name="sgc_eventgroups" id="sgc_eventgroups" value="<?= $event_groups ?>">
            <a href="#TB_inline?width=600&height=550&inlineId=sgc_event_group_add" class="thickbox button" id="sgc_managegroups">Manage Groups</a>
		</td>
	</tr>
	</tbody>
</table>
</div>



<div id="sgc_event_group_add" style="display:none;">
    <div class="container" style="padding: 6px">
        <div style="float: right"><a href="" class="button-primary thickbox" id="sgc_event_groupsave">Save</a></div>
        <h1 style="display:inline">Manage Groups</h1>&nbsp;
        <a href="" class="button-secondary thickbox" id="sgc_event_groupadd" >Add</a>
        <div id="sgc_event_grouplist">
        
        </div>
    </div>
</div>

