<?php
/**
 * 
 * @author Matthew Linton
 *
 */
class SGC_Locations
{
    
    /**
     *
     */
    public function create_post_type_locations() {
        $labels = array(
            'name' => 'Locations',
            'singular_name' => 'Location',
            'add_new' => 'Add New Location',
            'add_new_item' => 'Add New Location',
            'edit_item' => 'Edit Location',
            'new_item' => 'New Location',
            'all_items' => 'All Locations',
            'view_item' => 'View Locations',
            'search_items' => 'Search Locations',
            'not_found' =>  'No Locations Found',
            'not_found_in_trash' => 'No Locations found in Trash',
            'parent_item_colon' => '',
            'menu_name' => 'Locations'
        );
        
        register_post_type( 'sgc_location', array(
            'labels' => $labels,
            'has_archive' => true,
            'public' => true,
            'supports' => array( 'title', 'thumbnail', 'editor'),
            'taxonomies' => array( '' ),
            'exclude_from_search' => false,
            'capability_type' => 'post',
            'rewrite' => array( 'slug' => 'sgc_locations' ),
            'menu_icon' => 'dashicons-location-alt'
        ));
    }
    
    /**
     *
     */
    public function add_locations_fields() {
        add_meta_box(
            'sgc_custom_location_fields',           // Unique ID
            'Location Details',  // Box title
            array('SGC_Locations', 'locations_fields_html'),
            'sgc_location',
            'side'
            );
    }
    
    /**
     *
     */
    function locations_fields_html() {
        global $post;
        
        $location_address = get_post_meta($post->ID, 'sgc_locationaddress', true);
        $location_website = get_post_meta($post->ID, 'sgc_locationwebsite', true);
        
        include_once( plugin_dir_path( dirname( __FILE__ ) ) . 'admin/partials/sgc-admin-locations.php' );
    }
    
    /**
     *
     */
    function save_locations_meta($post_id)
    {
        if (array_key_exists('sgc_locationaddress', $_POST)) {
            update_post_meta(
                $post_id,
                'sgc_locationaddress',
                $_POST['sgc_locationaddress']
                );
        }
        
        if (array_key_exists('sgc_locationwebsite', $_POST)) {
            update_post_meta(
                $post_id,
                'sgc_locationwebsite',
                $_POST['sgc_locationwebsite']
                );
        }
    }
}

