<?php
/**
 * 
 * @author Matthew Linton
 *
 */
class SGC_Teams
{
    
    /**
     *
     */
    public function create_post_type_teams() {
        $labels = array(
            'name' => 'Teams',
            'singular_name' => 'Team',
            'add_new' => 'Add New Team',
            'add_new_item' => 'Add New Team',
            'edit_item' => 'Edit Team',
            'new_item' => 'New Team',
            'all_items' => 'All Teams',
            'view_item' => 'View Team',
            'search_items' => 'Search Teams',
            'not_found' =>  'No Teams Found',
            'not_found_in_trash' => 'No Teams found in Trash',
            'parent_item_colon' => '',
            'menu_name' => 'Teams'
        );
        
        register_post_type( 'sgc_team', array(
            'labels' => $labels,
            'has_archive' => true,
            'public' => true,
            'supports' => array( 'title', 'editor', 'thumbnail'),
            'taxonomies' => array( '' ),
            'exclude_from_search' => false,
            'capability_type' => 'post',
            'rewrite' => array( 'slug' => 'sgc_teams' ),
            'menu_icon' => 'dashicons-groups'
        ));
    }
    
    /**
     *
     */
    public function add_team_rest() {
        register_rest_route( 'simplegolfclub/v1', '/team/players/(?P<id>\d+)', array(
            'methods' => 'GET',
            'callback' => array('SGC_teams', 'get_rest_team_players'),
        ) );
    }
    
    /**
     *
     */
    public function add_teams_fields($posts) {
        add_meta_box(
            'sgc_custom_team_players',
            'Players',
            array('SGC_Teams', 'team_players_list_html'),
            'sgc_team',
            'side',
            'low'
            );
    }
    
    /**
     *
     */
    public function team_players_list_html($posts) {
        global $wpdb, $post;
        
        // fetch team list
        $players_available = get_posts(array(
            'meta_query' => array(
                array(
                    'key' => 'sgc_playerteam',
                    'value' => -1
                )
            ),
            'post_status' => 'publish',
            'post_type' => 'sgc_player',
            'orderby' => 'post_title',
            'order' => 'ASC',
            'posts_per_page' => -1
        ));
        
        // fetch player list for this team
        $team_players = get_posts(array(
            'meta_query' => array(
                array(
                    'key' => 'sgc_playerteam',
                    'value' => $post->ID
                )
            ),
            'post_status' => 'publish',
            'post_type' => 'sgc_player',
            'orderby' => 'post_title',
            'order' => 'ASC',
            'posts_per_page' => -1
        ));
        
        include_once( plugin_dir_path( dirname( __FILE__ ) ) . 'admin/partials/sgc-admin-teams.php' );
    }
    
    /**
     *
     */
    public function get_rest_team_players( $data ) {
        // fetch player list
        $posts = get_posts(array(
            'meta_query' => array(
                array(
                    'key' => 'sgc_playerteam',
                    'value' => $data['id']
                )
            ),
            'post_status' => 'publish',
            'post_type' => 'sgc_player',
            'orderby' => 'post_title',
            'order' => 'ASC',
            'posts_per_page' => -1
        ));
        
        if ( empty( $posts ) ) { return null; }
        return wp_send_json($posts);
    }
}

