/**
 * All the scripts needed for the events custom post type
 */
 
class SGC_Event {

    constructor( jQuery ) {
        SGC_Event.$ = jQuery;
        
        SGC_Event.eventid = SGC_Event.$('#sgc_eventid').val();
        SGC_Event.groups = [];
        SGC_Event.players = [];
        SGC_Event.checkin = [];
        
        SGC_Event.get_groups( SGC_Event.$);
        SGC_Event.get_checkin( SGC_Event.$ );
    }

    /**
     * 
     */
    static isCheckedin( playerid ) {
        var isAvailable = false;
        
        for ( var i = 0 ; i < SGC_Event.checkin.length ; i ++ ) {
            if ( SGC_Event.checkin[i] == playerid ) {
                isAvailable = true;
            }
        }
        return isAvailable;
    }
    
    /**
     * 
     */
    static toggleCheckedin ( ) {
        var playerid = SGC_Event.$(this).attr('player');
        var checkedin = false;
        
        for ( var i = 0 ; i < SGC_Event.checkin.length ; i ++ ) {
            if ( SGC_Event.checkin[i] == playerid ) {
                // Delete the playerid from checkin
                SGC_Event.checkin.splice( i, 1 );
                checkedin = true;
            }
        }
        
        if ( checkedin == false ) {
            // append theis playerid to checkedin
            SGC_Event.checkin.push( playerid );
        }
        
        // Update the list of checkedin players
        SGC_Event.$.getJSON(SGC.siteurl + '/wp-json/simplegolfclub/v1/event/checkin/' + SGC_Event.eventid + '/' + playerid, function (result) {
        }).done(function () {
            SGC_Event.get_checkin ( SGC_Event.$ );
        });
        return false;
    }
    
    /**
     * 
     */
    static get_groups( $ ) {
        // fetch group JSON array from REST
        $.getJSON(SGC.siteurl + '/wp-json/simplegolfclub/v1/event/groups/' + SGC_Event.eventid, function (result) {
            try {
                SGC_Event.groups = JSON.parse(result.replace(/[']/g, '\"'));
            } catch (e) {
                console.log('not a valid json string');
            }
        }).done(function () {
            if ( SGC_Event.groups.length > 0 ) { SGC_Event.display_groups( $ ); }
        });
    }

    /**
     * 
     */
    static display_groups( $ ) {
        // Clear the grouplist
        $('#sgc_eventgroups').html('<h4>Groups:</h4>');
        
        // Loop through the group array and build the group dialogs
        for (var i = 0; i < SGC_Event.groups.length; i++) {
            // Create the group container
            $('#sgc_eventgroups')
                    .append('<div class="sgc_eventgroup" id="sgc_eventgroup_' + i + '" '
                            + '" style="display: inline-block"></div>');

            // Add the group Heading
            if ( SGC_Event.groups[i].name != '' ) {
                $('#sgc_eventgroup_' + i)
                        .append('<div class="sgc_eventgroup_name">'
                                + '<h5>' + SGC_Event.groups[i].name + '</h5>'
                                + '</div>');
            } else {
                $('#sgc_eventgroup_' + i)
                        .append('<div class="sgc_eventgroup_name">'
                                + '<h5>Group #' + eval( i + 1 ).toString().padStart(2, '0') + '</h5>'
                                + '</div>');
            }
            // Add the group body
            $('#sgc_eventgroup_' + i)
                    .append('<div class="sgc_eventgroup_players" id="sgc_eventgroup_' + i + '_players">'
                            + '<ul id="sgc_eventgroup_' + i + '_players"></ul>'
                            + '</div>');

            // Populate the group body
            if (SGC_Event.groups[i].players.length > 0) {
                for (var j = 0; j < SGC_Event.groups[i].players.length; j++) {
                    $('ul[id=sgc_eventgroup_' + i + '_players]')
                        .append('<li class="sgc_eventgroup_players">'
                            + '<a href="TODO">' + SGC_Event.groups[i].players[j].name + '</a>'
                            + '</li>');
                }
            } else {
                $('ul[id=sgc_eventgroup_' + i + '_players]')
                        .append('<li class="sgc_eventgroup_players">TBD</li>');
            }
        }
    }
    
    static get_checkin( $ ) {
        // fetch checkin JSON array from REST
        $.getJSON(SGC.siteurl + '/wp-json/simplegolfclub/v1/event/checkin/' + SGC_Event.eventid, function (result) {
            if ( result != 'null' && result != null ) {
                SGC_Event.checkin = JSON.parse( result );
            }
        }).done(function () {
            if ( SGC_Event.checkin != null && SGC_Event.checkin.length > 0 ) { SGC_Event.display_checkin( $ ); }
        });
        
        // fetch players JSON array from REST
        $.getJSON(SGC.siteurl + '/wp-json/simplegolfclub/v1/event/players/' + SGC_Event.eventid, function (result) {
            if ( result != 'null' && result != null ) {
                SGC_Event.players = result;
            }
        }).done(function () {
            if ( SGC_Event.players != null && SGC_Event.players.length > 0 ) { SGC_Event.display_checkin( $ ); }
        });
    }
    
    static display_checkin ( $ ) {  
        // Clear the checkin list
        $('#sgc_eventcheckin').html('<h4>Check-In:</h4>'
                + '<table class="sgc_playertable">'
                + '<thead><tr><td>Un-Available</td><td>Available</td></tr></thead>'
                + '<tbody id="sgc_checkintable"></tbody></table>');
        
        // Populate the available players
        for (var i = 0; i < SGC_Event.players.length; i++) {
            // Check for matching player ID in checkedin list
            if  ( SGC_Event.isCheckedin( SGC_Event.players[i].ID ) ) {
                $('#sgc_checkintable').append('<tr>'
                        + '<td class="sgc_playertable">&nbsp;</td>'
                        + '<td class="sgc_playertable">' 
                        + '<a href="" class="sgc_checkintable" id="sgc_checkintable_' + i + '" '
                        + 'player="' + SGC_Event.players[i].ID + '">'
                        + SGC_Event.players[i].post_title 
                        + '</a></td></tr>');
            } else {
                $('#sgc_checkintable').append( '<tr>'
                        + '<td class="sgc_playertable">' 
                        + '<a href="" class="sgc_checkintable" id="sgc_checkintable_' + i + '" '
                        + 'player="' + SGC_Event.players[i].ID + '">'
                        + SGC_Event.players[i].post_title 
                        + '</td><td class="sgc_playertable">&nbsp;</td></tr>' );
            }
            
            // Attach click event
            $('#sgc_checkintable_' + i).click( SGC_Event.toggleCheckedin );
        }
    }
    
}
